Project/Siteguide.Web/Controllers/AboutController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Reflection;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using SiteGuide.Service;
using SiteGuide.Web.Models;
using SiteGuide.DAL;

namespace SiteGuide.Web.Controllers
{
    public class AboutController : Controller
    {
        private readonly SiteGuideContext _context;
        private readonly VersionService _versionService;

        public AboutController(SiteGuideContext context, VersionService versionService)
        {
            _context = context;
            _versionService = versionService;
        }

        public async Task<IActionResult> IndexAsync()
        {
            var version = Assembly.GetExecutingAssembly().GetName().Version;
            DateTime buildDate = new DateTime(2000, 1, 1)
                .AddDays(version.Build)
                .AddSeconds(version.Revision * 2);

            var versionInfo = await _versionService.GetVersionInfoAsync();

            var model = new AboutViewModel
            {
                StateAssociations = _context.ExtCacheClub
                    .Where(i => i.Category == "a")
                    .ToList(),

                SoftwareVersion = version,
                SoftwareBuildDate = buildDate,
                DataVersion = versionInfo.Id,
                DataVersionDateTime = versionInfo.PublishedTime,
            };

            return View(model);
        }
    }
}

Project/Siteguide.Web/Controllers/MapController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Geo;
using MarkdownSharp;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Internal;
using Microsoft.Extensions.Configuration;
using SiteGuide.Service.Helpers;
using SiteGuide.Web.Helpers;
using SiteGuide.Web.Models;
using SiteGuide.DAL;
using SiteGuide.DAL.Models;
using SiteGuide.Service.Extensions;
using SiteGuide.Service.Identifiers;
using System.Net;

namespace SiteGuide.Web.Controllers
{
    public class MapController : Controller
    {
        private readonly SiteGuideContext _context;
        private readonly IConfiguration _configuration;

        public MapController(SiteGuideContext context, IConfiguration configuration)
        {
            _context = context;
            _configuration = configuration;
        }

        // GET: Map
        public async Task<IActionResult> Index()
        {
            ViewBag.GmapsApiKey = _configuration.GetValue<string>("GMaps:ApiKey");

            return View();
        }

        // GET: data
        public async Task<IActionResult> Data([FromQuery] string versionTreeNodeIdentifier = null)
        {
            VersionTreeNodeIdentifier versionTreeNode = string.IsNullOrWhiteSpace(versionTreeNodeIdentifier)
                ? null
                : VersionTreeNodeIdentifier.FromIdentifier(versionTreeNodeIdentifier, _context);

            Markdown markdownTransformer = new();

            string versionInfo = versionTreeNode switch
            {
                null => null,
                EditVersionIdentifier ev => ev.IdAndVersionNumber,
                VersionIdentifier v => v.Id.ToString(),
                //VersionIdentifier v => new Service.VersionInfo
                //{
                //    Id = v.Id,
                //    AppliedEditVersion = await _context.EditVersion
                //        .AsNoTracking()
                //        .SingleAsync(ev =>
                //            ev.EditId == v.EditId
                //            && ev.StatusId == "A")
                //},

                _ => throw new NotImplementedException(),
            };

            var sites = _context.Site
                .AsNoTracking()
                .ValidAtVersionTreeNode(versionTreeNode)
                .Select(s => new
                {
                    s.Id,
                    s.Name,
                    s.IsClosed,
                })
                .ToList()
                .GroupJoin(
                    _context.Launch
                    .AsNoTracking()
                    .ValidAtVersionTreeNode(versionTreeNode)
                    .Select(l => new
                    {
                        l.Id,
                        l.SiteId,
                        l.Name,
                        l.Lat,
                        l.Lon,
                        l.IsClosed,
                    })
                    .ToList(),
                s => s.Id, l => l.SiteId, (s, ll) => new
                {
                    s.Id,
                    s.Name,
                    s.IsClosed,
                    Launches = ll
                });

            var polyEncoderDetail = new PolylineEncoder(18, 2, 1e-5, true);

            var sitesByShapeId = _context.SiteMapshape
                .AsNoTracking()
                .ValidAtVersionTreeNode(versionTreeNode)
                .ToLookup(i => i.MapshapeId, i => i.SiteId);

            var shapes = _context.MapShape
                .AsNoTracking()
                .Include(m => m.Category)
                .ValidAtVersionTreeNode(versionTreeNode)
                .Select(m => new
                {
                    m.Id,
                    Category = m.Category.Name,
                    Coordinates = m.CoordinatesList,
                    m.Name,
                    m.Description,
                    m.EstaEmergencyMarker,
                })
                .ToList()
                .Select(m => new
                {
                    m.Category,
                    Coordinates = m.Coordinates.Select(p => polyEncoderDetail.DPEncode(Track.CreateFromPointsData(p, false))["encodedPoints"]),
                    m.Name,
                    Description = markdownTransformer.Transform(m.Description),
                    m.EstaEmergencyMarker,
                    SiteIds = sitesByShapeId[m.Id],
                });

            var clubs = await _context.ExtCacheClub
                .AsNoTracking()
                .Select(c => new
                {
                    c.Name,
                    c.Category,
                    c.Phone,
                    c.Email,
                    c.SafaCode,
                    Url = string.IsNullOrEmpty(c.Url) || c.Url.StartsWith("http") ? c.Url : "https://" + c.Url,
                    c.Lat,
                    c.Lng,
                })
                .ToListAsync();

            var mapShapeCategories = await _context.MapShapeCategory.ToListAsync();

            return Json(new
            {
                sites,
                shapes,
                clubs,
                mapShapeCategories,
                versionInfo,
            });
        }

        public async Task<IActionResult> CtafData()
        {
            var aerodromes = await _context.ExtCacheCtaf
                .AsNoTracking()
                .ToListAsync();

            var ersaEffectiveDate = _context.ExtCacheErsaEffectiveDate
                .Select(d => d.EffectiveDate)
                .Where(d => d <= DateOnly.FromDateTime(DateTime.Now))
                .OrderByDescending(d => d)
                .First()
                .ToString("ddMMMyyyy"); // Only used in link to ERSA FAC. Easiest to format here.

            return Json(new { aerodromes, ersaEffectiveDate });
        }

        public async Task<ActionResult> LaunchSummary(int? id)
        {
            if (id is null)
                return new BadRequestObjectResult($"Parameter missing: {nameof(id)}");

            var model = await GetLaunchSummaryModelAsync(_context, (int)id);

            if (model is null)
                return new BadRequestObjectResult($"Specified launch does not exist. {nameof(id)}: {id}");

            return PartialView("_LaunchSummary", model);
        }

        private async Task<LaunchInfo> GetLaunchSummaryModelAsync(SiteGuideContext context, int launchId)
        {
            var launch = context.Launch
                .ValidAtCurrentVersion()
                .SingleOrDefault(l => l.Id == launchId);
            if (launch == null)
                return null;
            var site = context.Site
                .ValidAtCurrentVersion()
                .Single(s => s.Id == launch.SiteId);

            var model = new LaunchInfo()
            {
                Site = site,
                Launch = launch,
            };
            model.Contacts = context.SiteContact
                .ValidAtCurrentVersion()
                .Where(sc => sc.SiteId == model.Site.Id)
                .ToList()
                .Join(
                    context.Contact
                        .ValidAtCurrentVersion(),
                    sc => sc.ContactId,
                    c => c.Id,
                    (sc, c) => new SiteContactInfo()
                    {
                        Contact = c,
                        IsContact = sc.IsContact,
                        IsResponsible = sc.IsResponsible,
                    }
                )
                .ToList();

            return model;
        }
    }
}

Project/Siteguide.Web/Controllers/VersionsController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using System.Linq.Expressions;
using System.Security.Cryptography;
using System.Threading.Tasks;
using DiffMatchPatch;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Diagnostics;
using Microsoft.CodeAnalysis.CSharp.Syntax;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Internal;
using Microsoft.EntityFrameworkCore.Query.Internal;
using Microsoft.Extensions.Configuration;
using SiteGuide.Web.Helpers;
using SiteGuide.Web.Models;
using SiteGuide.DAL.Models;
using SiteGuide.Service.Extensions;
using Version = SiteGuide.DAL.Models.Version;
using SiteGuide.DAL;
using Microsoft.AspNetCore.Identity;
using SiteGuide.Service.Identifiers;
using SiteGuide.Service;
using SiteGuide.Web.Extensions;
using Siteguide.Web.Authorisation;
using Microsoft.AspNetCore.Authorization;
using SiteGuide.Service.Helpers;

namespace SiteGuide.Web.Controllers
{
    public class VersionsController : Controller
    {
        private readonly SiteGuideContext _context;
        private readonly SiteService _siteService;
        private readonly VersionChangesDescriptorService _versionChangesService;
        private readonly VersionService _versionService;
        private readonly UserManager<IdentityUser> _userManager;

        public VersionsController(SiteGuideContext context, VersionChangesDescriptorService versionChangesService, VersionService versionService, UserManager<IdentityUser> userManager, SiteService siteService)
        {
            _context = context;
            _versionChangesService = versionChangesService;
            _versionService = versionService;
            _userManager = userManager;
            _siteService = siteService;

        }

        [AuthoriseSafaMember]
        public async Task<IActionResult> Index([FromQuery] string filterForSite)
        {
            if (string.IsNullOrEmpty(filterForSite))
                return View();

            // Ensure that there is a single match for this site
            var matches = await _siteService.FindSiteByNameAsync(filterForSite);
            if (matches.Count() != 1)
                return RedirectToAction("Search", "Sites", new { id = filterForSite, version = (string)null });
            var siteName = matches.Single().Name;

            return View((object)siteName);
        }

        [AuthoriseSafaMember]
        public async Task<IActionResult> Details(int id, int? compareToVersionId = null)
        {
            compareToVersionId ??= id - 1; // By default, compare to immediately preceding version

            var thisVersionInfo = await _versionService.GetVersionInfoAsync(id);
            var baseVersionInfo = await _versionService.GetVersionInfoAsync(compareToVersionId);

            if (thisVersionInfo is null)
                throw new KeyNotFoundException($"Version {id} does not seem to exist."); // TODO: Show useful message to user.

            // If baseVersionInfo is null, assume we're comparing to initial empty state.
            //if (baseVersionInfo is null)
            //    throw new KeyNotFoundException($"Version {compareToVersionId} does not seem to exist."); // TODO: Show useful message to user.

            //var thisVersionOrEditVersionId = new VersionIdentifier(id);

            var model = new VersionDetailsModel
            {
                ThisVersion = thisVersionInfo,
                CompareToVersion = baseVersionInfo,
                PreviousVersionExists = baseVersionInfo != null,
                NextVersionExists = _context.Version.Any(v => v.Id == thisVersionInfo.Id + 1),
            };

            return View(model);
        }

        /// <summary>
        /// Get list of all versions. If site is specified, only return those versions that changed the specified site.
        /// </summary>
        [AuthoriseSafaMember]
        [HttpGet("VersionsListPartial")]
        [HttpGet("VersionsListPartial/{siteName}")]
        public async Task<IActionResult> VersionsListPartial([FromRoute] string siteName) // TODO: We should probably use the id here rather than the name. Name could be duplicate over version history.
        {
            IEnumerable<VersionInfo> versionInfos;
            if (siteName is null)
                versionInfos = (await _versionService.GetVersionInfosAsync());
            else
            {
                var siteMatches = await _siteService.FindSiteByNameAsync(siteName);

                if (siteMatches.Count() != 1)
                    //return RedirectToAction("Search", new { id = matches[0].Name, version = (string)null });
                    throw new ArgumentException($"{nameof(siteName)} must exactly match the name of a specific site.");

                var site = siteMatches.Single();
                versionInfos = (await _versionService.GetVersionsForSiteAsync(site.Id));
            }

            return PartialView("_Versions", versionInfos.OrderByDescending(i => i.Id));
        }

        [AuthoriseSafaMember]
        [HttpGet("[controller]/Compare/{editId}.{editVersionNumber}")]
        public async Task<IActionResult> Compare([FromRoute] int editId, [FromRoute] int? editVersionNumber, [FromQuery] int? compareToVersion = null)
        {
            var currentUser = await _userManager.GetUserAsync(HttpContext.User);
            var model = await _versionChangesService.GetEditVersionChangesDetailsAsync(editId, editVersionNumber, compareToVersion, currentUser);
            if (model is null)
                return NotFound();
            if (model.ThisEdit.StatusId == "D" && !model.IsEditableByCurrentUser)
                return Forbid();

            return View(model);
        }

        //[AuthoriseSafaMember] // Allow for SAFA members or author
        [HttpGet("DetailsOfEditPartial/{treeNodeId}")]
        public async Task<IActionResult> DetailsOfEditPartial([FromRoute] string treeNodeId, [FromQuery] int? compareToVersion = null, [FromQuery] bool showViewButtons = false, [FromQuery] bool showEditButton = false)
        {
            var nodeId = VersionTreeNodeIdentifier.FromIdentifier(treeNodeId, _context);
            if (nodeId is null)
            {
                this.AddMessage(MessageType.Error, $"Edit {treeNodeId} does not exist.", "It may have been abandoned."); // TODO - wire up. Currently not displayed.
                return NotFound();
            }
            if (!(Permissions.IsSafaMember(User) || Permissions.IsAdmin(User)))
            {
                // If not a safa member of admin, then only show user's own edit versions and disallow compares
                if (compareToVersion != null)
                    return Unauthorized();
                switch (nodeId)
                {
                    case EditVersionIdentifier editVersionIdentifier:
                        var authorId = _context.EditVersion.Single(ev => ev.Id == editVersionIdentifier.Id).AuthorId;
                        if (authorId != _userManager.GetUserId(User))
                            return Unauthorized();
                        break;
                    case VersionIdentifier:
                        return Unauthorized();
                    default: throw new NotImplementedException();
                }
            }

            compareToVersion ??= nodeId switch // If compare to version isn't specified, set default:
            {
                EditVersionIdentifier editVersionId => editVersionId.ReferenceVersion,
                VersionIdentifier versionId => (await _context.Version.SingleOrDefaultAsync(v => v.Id == versionId.Id - 1))?.Id, // Immediately preceding version, if any
                _ => throw new NotImplementedException(),
            };

            var model = new ChangesViewModel
            {
                GroupedChanges = _versionChangesService.GetGroupedChanges(nodeId, compareToVersion),
                ThisVersionId = nodeId,
                CompareToVersionId = compareToVersion,
                ShowButtons = showViewButtons,
                ShowEditButton = showEditButton,
            };

            return PartialView("_Changes", model);
        }
    }
}

Project/Siteguide.Web/Views/Shared/Message.cshtml
@model SiteGuide.Web.Models.MessageViewModel

@{
    if (ViewBag.Title == null)
        ViewBag.Title = $"{Model.Type}: {Model.Title}";
}

<div class="alert alert-@(Model.Type switch {
            MessageType.Success => "success",
            MessageType.Error   => "danger",
            MessageType.Warning => "warning",
            _=> throw new NotImplementedException()
        })" role="alert">
    <h4 class="alert-heading">@Model.Title</h4>
    <p>@Model.Text</p>
</div>

Project/Siteguide.Web/Views/Shared/_EditStatus.cshtml
@using SiteGuide.DAL.Models
@using SiteGuide.Service
@using SiteGuide.Service.Identifiers
@using SiteGuide.Web.Helpers
@model EditVersion

<span class="badge badge-@EditVersionStatusHelper.BootstrapClass(Model.StatusId)">
    @EditVersionStatusHelper.StatusDescription(Model)
</span>

Project/Siteguide.Web/Views/Shared/_EditVersionHeader.cshtml
@model EditVersion
@using SiteGuide.Service.Helpers
@using SiteGuide.Web.Controllers
@using SiteGuide.Web.Helpers
@using SiteGuide.DAL.Models
@using SiteGuide.Service.Extensions
@using SiteGuide.Service.Identifiers

<hr />
<h4>
    @Model.EditVersionNumber <partial name="_EditStatus" />
</h4>
@if (Permissions.MaySeeAuthorName(User))
{
    <text>Author: @Model.AuthorName</text>
}
@if (Model.AuthorRole != null && Model.AuthorRole != "Unprivileged")
{
    <span>as </span>
    <span class="badge badge-dark">@Model.AuthorRole</span>
}
<br />
Created: @LocalTimeHelper.LocalTime(Model.InitialisedTime)
<br />
@if (Model.SubmittedTime != null)
{
    <text>Submitted: </text>

    @LocalTimeHelper.LocalTime((DateTime)Model.SubmittedTime)
    <br />
}
@if (!string.IsNullOrEmpty(Model.Comment))
{
    <span>Comment:</span>
    <blockquote>@Model.Comment</blockquote>
}

Project/Siteguide.Web/Views/Shared/_Layout.cshtml
@using Newtonsoft.Json;
@{
    Layout = "_LayoutBase.cshtml";
}

<div class="container">
    <partial name="_CookieConsentPartial" /> @*TODO: Move to layoutbase?*@

    @{
        var messages = TempData["Messages"] as IList<string>;
        if (messages != null)
        {
            foreach (var messageJson in messages)
            {
                var message = JsonConvert.DeserializeObject<MessageViewModel>(messageJson);
                var messageAlertClass = message.Type switch
                {
                    MessageType.Success => "success",
                    MessageType.Error => "danger",
                    MessageType.Warning => "warning",
                    _ => throw new NotImplementedException()
                };
                <div class="alert alert-@(messageAlertClass) alert-dismissible fade show" role="alert">
                    <h4 class="alert-heading">@message.Title</h4>
                    <p>@message.Text</p>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            }
        }
    }

    <main role="main" class="pb-3">
        @RenderBody()
    </main>
</div>

<footer class="border-top footer text-muted">
    <div class="container">
        <a href="mailto:webmaster@siteguide.org.au">Webmaster</a> | <a asp-area="" asp-controller="Home" asp-action="Disclaimer">Disclaimer</a>
    </div>
</footer>

@section scripts{
    @RenderSection("Scripts", required: false)
    }

Project/Siteguide.Web/Views/Shared/_LayoutBase.cshtml
@using Microsoft.EntityFrameworkCore
<environment exclude="Production">
    <environment exclude="Test">
        @inject SiteGuide.DAL.SiteGuideContext context
    </environment>
</environment>
@inject Microsoft.AspNetCore.Hosting.IWebHostEnvironment hostingEnv
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Site Guide</title>
    <environment include="Development">
        <link rel="stylesheet" href="/css/bootstrap.css" />
    </environment>
    <environment exclude="Development">
        @*     <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" asp-fallback-href="/lib/bootstrap/dist/css/bootstrap.min.css" asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute" crossorigin="anonymous" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" /> *@
        <link rel="stylesheet" href="/css/bootstrap.min.css" />
    </environment>
    <link rel="stylesheet" href="/css/site.css" />
    @* <link rel="stylesheet" href="https://cdn.rawgit.com/afeld/bootstrap-toc/v1.0.1/dist/bootstrap-toc.min.css" /> *@
</head>
<body>
    <header>
        <div class="environment-header">
            <environment exclude="Production">
                @hostingEnv.EnvironmentName
                <environment exclude="Test">- DB "@context.Database.GetDbConnection().Database"</environment>
                <environment include="Test"> - some or all data may be fictitious. For the live site see <a href="https://siteguide.org.au">siteguide.org.au</a>.</environment>
            </environment>
        </div>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-dark border-bottom box-shadow mb-3 bg-primary">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">Australian National Site Guide</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    @await Component.InvokeAsync("LoginMenu")
                    <ul class="navbar-nav flex-grow-1">
                        @*<li class="nav-item">
                        <a class="nav-link text-light" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>*@
                        <li class="nav-item">
                            <a class="nav-link text-light" asp-area="" asp-controller="Sites" asp-action="Index">Sites</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-light" asp-area="" asp-controller="Map" asp-action="Index">Map</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-light" asp-area="" asp-controller="Downloads" asp-action="Index">Downloads</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-light" asp-area="" asp-controller="About" asp-action="Index">About</a>
                        </li>
                        @*<li class="nav-item">
                        <a class="nav-link text-light" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>*@
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    @RenderBody()

    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.js"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=">
        </script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-xrRywqdh3PHs8keKZN+8zzc5TX0GRTLCcmivcbNJWm2rs5C8PRhcEn3czEjhAO9o">
        </script>
    </environment>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @* <script src="https://cdn.rawgit.com/afeld/bootstrap-toc/v1.0.1/dist/bootstrap-toc.min.js"></script> *@
    @RenderSection("Scripts", required: false)
</body>
</html>

Project/Siteguide.Web/Views/Shared/_Versions.cshtml
@model IEnumerable<VersionInfo>
@using SiteGuide.Service
@using SiteGuide.Service.Helpers
@using SiteGuide.Web.Controllers
@using SiteGuide.Web.Helpers
@using SiteGuide.DAL.Models
@using SiteGuide.Service.Extensions
@using SiteGuide.Service.Identifiers

<div class="table-responsive-xl">
    <table class="table highlight-row linkify">
        <thead>
            <tr>
                <th>
                    Version
                </th>
                <th style="min-width: 12em;">
                    Published
                </th>
                <th>
                    Comment
                </th>
                <th style="min-width: 25em;">
                    Edit Versions
                </th>
            </tr>
        </thead>
        <tbody>
            @foreach (var version in Model)
            {
                <tr class="data">
                    <td class="text-right"><a asp-controller="Versions" asp-action="Details" asp-route-id="@version.Id">@version.Id</a></td>
                    <td>
                        @LocalTimeHelper.LocalTime((System.DateTime)version.PublishedTime)
                    </td>
                    <td><blockquote>@version.Comment</blockquote></td>
                    <td>
                        <partial name="./_EditVersionsSummary" model="version.EditVersions" view-data='new ViewDataDictionary(ViewData) { { "ShowComments", false } }' />
                    </td>
                </tr>
            }
        </tbody>
    </table>
</div>